module Oximeter
  module Configuration

    class << self
      attr_reader :registry

      def entity_to_key(entity)
        if entity.is_a?(Class)
          entity.name.to_sym
        elsif entity.is_a?(String) || entity.is_a?(Symbol)
          entity.to_sym
        else
          entity.class.name.to_sym
        end
      end


      def model(entity, &block)
        key = entity_to_key(entity)

        @registry[key] ||= Oximeter::Configuration::Model.new(entity)
        @registry[key].instance_eval(&block) if block
        @registry[key]
      end

      def included_models
        @registry.keys.map { |key| @registry[key] }
      end

      def get_model(entity)
        key = entity_to_key(entity)
        @registry[key]
      end

      def reset!
        @registry = {}
      end

    end

    reset!
  end
end