module Oximeter
  module Configuration
    class Model
      attr_reader :entity, :setup

      ATTRIBUTES = %w(
        label
        pull_last
        period
        group_field
      ).freeze

      def initialize(entity)
        @entity = entity
        @setup = {}
      end

      # Define methods for setting model section configuration setup
      ATTRIBUTES.each do |attribute_name|
        define_method(attribute_name) do |attribute_value = nil|
          if attribute_value
            @setup[attribute_name.to_sym] = attribute_value
          else
            @setup[attribute_name.to_sym]
          end
        end
      end


    end
  end
end